﻿* Encoding: UTF-8.
*Compare partitions
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_CLUAGREE*/vers1*************************************************************************.
define !KO_cluagree(vars= !charend('/') /measure= !charend('/') /asymm= !charend('/') /normz= !charend('/') /print= !charend('/'))
!let !ok= 1
!if (!head(!tail(!vars))='WITH') !then !let !with= 1
 !let !clvrs= !conc(!head(!vars),!tail(!tail(!vars))) !let !nr= 'p-1' !let !nc= 1 !let !nit= 1 !let !ind= ':'
 !let !c1= '{s,' !let !c2= '}' !let !vnam= !null !let !vlab= !null
 !if (!asymm='BOTH') !then !let !ok= 0
- echo ''.
- echo '>ERROR. ASYMM=BOTH is incompatible with keyword WITH in VARS.'.
 !ifend
!else !let !with= 0 !let !clvrs= !vars !let !nr= 'p' !let !nc= 'p' !let !nit= 'p-1' !let !ind= 'ind'
 !let !sim= 1
 !if (!tail(!measure)<>!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. MEASURE= several measures requires keyword WITH in VARS.'.
 !ifend
!ifend
!if (!ok) !then
-echo '**** COMPARISON OF PARTITIONS (!KO_CLUAGREE) ****'.
-set mxloops 1000000.
-matrix.
-get clas /vari= !clvrs /names= names.
-comp s= t(names(2:ncol(names))).
-comp n= nrow(clas).
-comp p= ncol(clas).
 !let !measa= 0 !let !measb= 0 !let !meas= !conc(' ',!measure,' ')
 !do !w !in (!measure) !let !w_= !conc(' ',!w,' ')
  !if (!index(' DICE OCHIAI KULCZ2 JACCARD RAND ARAND RR RT SS2 SS1 PHI DISPER SEUCLID MN ',!w_)>0) !then
   !let !measa= 1 !break
  !ifend
 !doend
 !do !w !in (!measure) !let !w_= !conc(' ',!w,' ')
  !if (!index(' OVL FCA MI NMI VI AMI HCV ',!w_)>0) !then
   !let !measb= 1 !let !nmb= 7 !break
  !ifend
 !doend
 !if (!measa) !then
- comp ones= make(1,n,1).
- comp nn= n**2.
- comp np= (nn-n)/2.
- comp pairs= make(p,np,0).
- comp clas= t(clas).
- loop i= 1 to p.
-  do if i=1.
-   comp uind= make(1,np,0).
-   loop i2= 1 to n-1.
-    comp ind= i2*n+(1-n+i2):0.
-    comp st= -(n-1)+(n+.5)*i2-.5*i2**2.
-    comp uind(st:(st+ncol(ind)-1))= ind.
-   end loop.
-  end if.
-  comp clai= clas(i,:)(ones,:).
-  comp pairs(i,:)= reshape(clai=t(clai),1,nn)(uind).
- end loop.
- release clai,uind.
- comp a= make(!nr,!nc,0).
- comp b= make(!nr,!nc,0).
- comp c= make(!nr,!nc,0).
- comp d= make(!nr,!nc,0).
- loop i= 1 to !nit.
-  comp pairs1= pairs(i,:).
-  comp pairs1= pairs1(make(1,p-i,1),:).
-  comp ind= (i+1):p.
-  comp pairs2= pairs(ind,:).
-  comp a(!ind,i)= rsum(pairs1&*pairs2).
-  comp pairs2= not pairs2.
-  comp b(!ind,i)= rsum(pairs1&*pairs2).
-  comp d(!ind,i)= rsum((not pairs1)&*pairs2).
-  comp c(!ind,i)= np-a(!ind,i)-b(!ind,i)-d(!ind,i).
- end loop.
  !if (!nc='p') !then
-  comp a= a+t(a).
-  comp b= b+t(b).
-  comp c= c+t(c).
-  comp d= d+t(d).
-  call setdiag(a,1).
-  call setdiag(b,1).
-  call setdiag(c,1).
-  call setdiag(d,1).
  !ifend
  !if (!print='YES') !then
-  print /title '[**** For measures based on Comembership Confusion Matrix ****]'.
-  print /title 'Comembership (pair) counts A, B, C, D between the compared variables:' /space= 0.
-  print a.
-  print b.
-  print c.
-  print d.
  !ifend
  !let !dok= !null
  !do !w !in ('DICE OCHIAI KULCZ2')
   !if (!index(!meas,!conc(' ',!w,' '))>0) !then !let !dok= !conc(!dok,' ') !ifend
  !doend
  !let !dok= !len(!dok)
  !if (!dok>0) !then
-  comp rec= a/(a+b).
-  comp pre= a/(a+c).
   !if (!asymm='NO' !or !asymm=!null) !then
    !if (!index(!meas,' DICE ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' dice') !let !vlab= !conc(!vlab,' dice "Dice (Comembership F1)"') !ifend
-    comp s= !c1 2*pre&*rec/(pre+rec+(pre+rec=0)) !c2.
    !ifend
    !if (!index(!meas,' OCHIAI ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' ochiai') !let !vlab= !conc(!vlab,' ochiai "Ochiai (Folkes-Mallows)"') !ifend
-    comp s= !c1 sqrt(pre&*rec) !c2.
    !ifend
    !if (!index(!meas,' KULCZ2 ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' kulcz2') !let !vlab= !conc(!vlab,' kulcz2 "Kulczynski 2"') !ifend
-    comp s= !c1 (pre+rec)/2 !c2.
    !ifend
   !else
    !if (!asymm='VU') !then !let !app= 'Comembership Precision'
     !do !i= 1 !to !dok
-     comp s= !c1 pre !c2.
     !doend
    !else !if (!asymm='UV') !then !let !app= 'Comembership Recall'
     !do !i= 1 !to !dok
-     comp s= !c1 rec !c2.
     !doend
    !else !if (!asymm='BOTH') !then !let !app= 'Comembership Recall (above) & Precision (below)'
-    loop r= 2 to p.
-     loop c= 1 to r-1.
-      comp rec(r,c)= pre(r,c).
-     end loop.
-    end loop.
-    comp s= rec.
    !ifend !ifend !ifend
    !if (!index(!meas,' DICE ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' dice') !let !vlab= !conc(!vlab,' dice ',!quote(!app)) !ifend
    !ifend
    !if (!index(!meas,' OCHIAI ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' ochiai') !let !vlab= !conc(!vlab,' ochiai ',!quote(!app)) !ifend
    !ifend
    !if (!index(!meas,' KULCZ2 ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' kulcz2') !let !vlab= !conc(!vlab,' kulcz2 ',!quote(!app)) !ifend
    !ifend
   !ifend
-  release rec,pre.
  !ifend
  !if (!index(!meas,' JACCARD ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' jaccard') !let !vlab= !conc(!vlab,' jaccard "Jaccard"') !ifend
-  comp s= !c1 a/(a+b+c) !c2.
  !ifend
  !if (!index(!meas,' RAND ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' rand') !let !vlab= !conc(!vlab,' rand "Rand (Simple matching)"') !ifend
-  comp s= !c1 (a+d)/np !c2.
  !ifend
  !if (!index(!meas,' ARAND ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' arand') !let !vlab= !conc(!vlab,' arand "Adjusted Rand"') !ifend
-  comp s= !c1 2*(a&*d-b&*c)/((a+b)&*(d+b)+(a+c)&*(d+c)) !c2.
  !ifend
  !if (!index(!meas,' RR ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' rr') !let !vlab= !conc(!vlab,' rr "Russel-Rao"') !ifend
-  comp s= !c1 a/np !c2.
  !ifend
  !if (!index(!meas,' RT ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' rt') !let !vlab= !conc(!vlab,' rt "Rogers-Tanimoto"') !ifend
-  comp s= !c1 (a+d)/(np+b+c) !c2.
  !ifend
  !if (!index(!meas,' SS2 ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' ss2') !let !vlab= !conc(!vlab,' ss2 "Sokal-Sneath 2"') !ifend
-  comp s= !c1 a/(a+2*(b+c)) !c2.
  !ifend
  !if (!index(!meas,' SS1 ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' ss1') !let !vlab= !conc(!vlab,' ss1 "Sokal-Sneath 1"') !ifend
-  comp s= !c1 2*(a+d)/(2*(a+d)+b+c) !c2.
  !ifend
  !if (!index(!meas,' PHI ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' phi') !let !vlab= !conc(!vlab,' phi "Phi corr"') !ifend
-  comp s= !c1 (a&*d-b&*c)/sqrt((a+b)&*(a+c)&*(b+d)&*(c+d)) !c2.
  !ifend
  !if (!index(!meas,' DISPER ')>0) !then
   !if (!with) !then !let !vnam= !conc(!vnam,' disper') !let !vlab= !conc(!vlab,' disper "Dispersion simil"') !ifend
-  comp s= !c1 (a&*d-b&*c)/np**2 !c2.
  !ifend
  !if (!index(!meas,' SEUCLID ')>0) !then !let !sim= 0
   !if (!with) !then !let !vnam= !conc(!vnam,' seuclid') !let !vlab= !conc(!vlab,' seuclid "Sq Euclidean (Hamming) dist"') !ifend
-  comp s= !c1 b+c !c2.
-  !if (!not !with) !then
-   call setdiag(s,0).
-  !ifend
  !ifend
  !if (!index(!meas,' MN ')>0) !then !let !sim= 0
   !if (!with) !then !let !vnam= !conc(!vnam,' mn') !let !vlab= !conc(!vlab,' mn "McNemar dist"') !ifend
-  comp s= !c1 abs(b-c)/sqrt(b+c+(b+c=0)) !c2.
  !ifend
- release a,b,c,d,ones,pairs,pairs1,pairs2.
 !ifend
 !if (!measb) !then
  !if (!with) !then !let !rc= 'j-1,col'
-  comp cols= ncol(s).
-  comp s= {s,make(p-1,!nmb,0)}.
  !else !let !rc= 'i,j'
-  comp s= make(p,p,0).
   !if (!asymm='BOTH') !then !let !tosymm= 0 !else !let !tosymm= 1 !ifend
  !ifend
  !if (!measa) !then
-  comp clas= t(clas).
  !ifend
  !if (!index(!meas,' AMI ')>0) !then
-  comp f= ln(1:n).
-  loop #i= 2 to n.
-   comp f(#i)= f(#i-1)+f(#i).
-  end loop.
  !ifend
  !if (!print='YES') !then
-  print /title '[**** For measures based on Group Crosstabulation ****]'.
  !ifend
- comp ncat= 0.
- comp des= make(n,1,0).
- loop i= 1 to p.
-  comp clasi= clas(:,i).
-  comp desi= design(clasi).
-  comp ncat= {ncat,ncol(desi)}.
-  comp des= {des,desi}.
- end loop.
- comp ncat= ncat(2:ncol(ncat)).
- comp des= des(:,2:ncol(des)).
- release clas.
- loop i= 1 to !nit.
-  comp ncati= ncat(i).
-  comp desi= des(:,1:ncati).
-  comp des= des(:,(ncati+1):ncol(des)).
-  comp pilei= t(desi)*des.
-  comp shift= 0.
-  loop j= i+1 to p.
-   comp end= ncat(j).
-   comp indvec= 1:end+shift.
-   comp m= pilei(:,indvec).
-   comp shift= indvec(end).
    !if (!print='YES') !then
-    print {i,j} /title 'Variable numbers (i,j)'.
-    print names({i,j}) /title 'Variable names (i,j)' /format=a8 /space= 0.
-    print m /title 'Frequency crosstabulation (i * j)' /space= 0.
    !ifend
-   comp rs= rsum(m).
-   comp cs= csum(m).
    !if (!with) !then
-    comp col= cols.
    !ifend
    !if (!index(!meas,' OVL ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' ovl') !let !vlab= !conc(!vlab,' ovl "Overlap simil"')
-     comp col= col+1.
     !ifend
     !if (!asymm='VU') !then
-     comp s(!rc)= rsum(cmax(m))/n.
-    !else
-     comp s(!rc)= csum(rmax(m))/n.
      !if (!asymm='BOTH') !then
-      comp s(j,i)= rsum(cmax(m))/n.
      !else !if (!asymm<>'UV') !then
-      comp s(!rc)= (s(!rc)+rsum(cmax(m))/n)/2.
      !ifend !ifend
     !ifend
    !ifend
    !if (!index(!meas,' FCA ')>0) !then
     !if (!with) !then !let !vnam= !conc(!vnam,' fca') !let !vlab= !conc(!vlab,' fca "F Clustering Accuracy simil"')
-     comp col= col+1.
     !ifend
-    comp m_r= m/(rs*make(1,ncol(m),1)).
-    comp m_p= m/cs(make(1,nrow(m),1),:).
-    comp f1= m_r+m_p.
-    comp f1= 2*m_r&*m_p/(f1+(f1=0)).
     !if (!asymm='VU') !then
-     comp s(!rc)= rsum(cs&*cmax(f1))/n.
     !else
-     comp s(!rc)= csum(rs&*rmax(f1))/n.
      !if (!asymm='BOTH') !then
-      comp s(j,i)= rsum(cs&*cmax(f1))/n.
      !else !if (!asymm<>'UV') !then
-      comp s(!rc)= (s(!rc)+rsum(cs&*cmax(f1))/n)/2.
      !ifend !ifend
     !ifend
-    release m_r,m_p,f1.
    !ifend
    !if (!index(!meas,' MI ')>0 !or !index(!meas,' NMI ')>0 !or !index(!meas,' VI ')>0 !or !index(!meas,' AMI ')>0 !or !index(!meas,' HCV ')>0) !then
-    comp m_= m/n.
-    comp rm_= rs/n.
-    comp cm_= cs/n.
-    comp m_= -msum(m_&*ln(m_+(m_=0))).
-    comp rm_= -csum(rm_&*ln(rm_+(rm_=0))).
-    comp cm_= -rsum(cm_&*ln(cm_+(cm_=0))).
-    comp mi= rm_+cm_-m_.
     !if (!index(!meas,' NMI ')>0 !or !index(!meas,' AMI ')>0) !then
      !if (!normz='MEAN') !then !let !nrmz= '(MEAN)"'
-      comp normz= (rm_+cm_)/2.
      !else !if (!normz='GMEAN') !then !let !nrmz= '(GMEAN)"'
-      comp normz= sqrt(rm_*cm_).
      !else !if (!normz='MIN') !then !let !nrmz= '(MIN)"'
-      comp normz= mmin({rm_,cm_}).
      !else !let !nrmz= '(MAX)"'
-      comp normz= mmax({rm_,cm_}).
      !ifend !ifend !ifend
     !ifend
     !if (!index(!meas,' MI ')>0) !then !let !tosymm= 1
      !if (!with) !then !let !vnam= !conc(!vnam,' mi') !let !vlab= !conc(!vlab,' mi "Mutual Information"')
-      comp col= col+1.
      !ifend
-     comp s(!rc)= mi.
     !ifend
     !if (!index(!meas,' NMI ')>0) !then !let !tosymm= 1
      !if (!with) !then !let !vnam= !conc(!vnam,' nmi') !let !vlab= !conc(!vlab,' nmi "Normalized Mutual Information ',!nrmz)
-      comp col= col+1.
      !ifend
-     comp s(!rc)= mi/normz.
     !ifend
     !if (!index(!meas,' VI ')>0) !then !let !sim= 0 !let !tosymm= 1
      !if (!with) !then !let !vnam= !conc(!vnam,' vi') !let !vlab= !conc(!vlab,' vi "Variation of Information dist"')
-      comp col= col+1.
      !ifend
-     comp s(!rc)= rm_+cm_-2*mi.
     !ifend
     !if (!index(!meas,' AMI ')>0) !then !let !tosymm= 1
      !if (!with) !then !let !vnam= !conc(!vnam,' ami') !let !vlab= !conc(!vlab,' ami "Adjusted Mutual Information ',!nrmz)
-      comp col= col+1.
      !ifend
-     comp em= make(nrow(m),ncol(m),0).
-     loop r= 1 to nrow(m).
-      comp a= rs(r).
-      loop c= 1 to ncol(m).
-       comp b= cs(c).
-       comp x= mmax({1,a+b-n}):mmin({a,b}).
-       comp ax_= a-x.
-       comp bx_= b-x.
-       comp nabx_= n-a-b+x.
-       comp rhm= f(a)+f(b)+f(n-a)+f(n-b)-(f(n)+f(x+(x=0))+f(ax_+(ax_=0))+f(bx_+(bx_=0))+f(nabx_+(nabx_=0))).
-       comp em(r,c)= msum(x/n&*ln(n*x/(a*b))&*exp(rhm)).
-      end loop.
-     end loop.
-     comp emi= msum(em).
-     comp s(!rc)= (mi-emi)/(normz-emi).
-     release em,rhm,nabx_,bx_,ax_,x.
     !ifend
     !if (!index(!meas,' HCV ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' hcv') !let !vlab= !conc(!vlab,' hcv "Homogeneity & Completeness V"')
-      comp col= col+1.
      !ifend
-     do if rm_.
-      comp h_= 1-(m_-cm_)/rm_.
-     else.
-      comp h_= 1.
-     end if.
-     do if cm_.
-      comp c_= 1-(m_-rm_)/cm_.
-     else.
-      comp c_= 1.
-     end if.
      !if (!asymm='VU') !then
-      comp s(!rc)= h_.
      !else
-      comp s(!rc)= c_.
       !if (!asymm='BOTH') !then
-       comp s(j,i)= h_.
       !else !if (!asymm<>'UV') !then
-       comp s(!rc)= 2*h_*c_/(h_+c_). 
       !ifend !ifend
      !ifend
     !ifend
    !ifend
-  end loop.
- end loop.
  !if (!with) !then
-  comp s= s(:,1:col).
  !else !if (!tosymm) !then
-  comp s= s+t(s).
  !ifend !ifend
 !ifend
 !if (!with) !then
- save s /out= * /vari= varname_ /string= varname_.
 !else
  !if (!sim) !then
-  call setdiag(s,1).
  !ifend
- comp vnam= {'rowtype_','varname_',names}.
- save {make(p,1,'PROX'),t(names),s} /out= * /names= vnam /string= rowtype_ varname_.
 !ifend 
-end matrix.
 !if (!with) !then
- rename vari (all=varname_ !vnam).
- var lab  varname_ !quote(!conc('Partitions compared with partition ',!head(!vars))) !vlab.
- format !vnam (f8.3).
- echo '** COMPARISON OF PARTITIONS - Results **'.
- summarize /tables= all /format= list nocasenum nototal /cells= none /title= 'Partitions comparison by "external clustering criteria"'.
 !else
- echo 'Square matrix of the requested measure was output in the new working dataset'.
- var lev all (sca) rowtype_ to varname_ (nom).
  !if (!sim) !then
-  val lab rowtype_ 'PROX' !quote(!conc('SIMILARITY ',!measure,' ',!app)).
  !else
-  val lab rowtype_ 'PROX' !quote(!conc('DISSIMILARITY ',!measure,' ',!app)).
  !ifend
 !ifend
!else
-echo '>!KO_CLUAGREE is not executed.'.
-exec.
!ifend
!enddefine.

*/*!KO_CLASAGREE*/vers1*************************************************************************.
define !KO_clasagree(vars= !charend('/') /measure= !charend('/') /binar= !charend('/') /beta= !charend('/') /print= !charend('/'))
!let !ok= 1
!if (!head(!tail(!vars))='WITH') !then !let !with= 1 /*Есть кл слово WITH, т е 
 !let !clvrs= !conc(!head(!vars),!tail(!tail(!vars))) !let !nit= 1 !let !vnam= !null !let !vlab= !null
!else !let !with= 0 !let !clvrs= !vars !let !nit= 'p-1'
 !let !sim= 1
 !if (!tail(!measure)<>!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. MEASURE= several measures requires keyword WITH in VARS.'.
 !ifend
 !if (!binar='CLASS') !then !let !ok= 0
- echo ''.
- echo '>ERROR. BINAR=CLASS requires keyword WITH in VARS.'.
 !ifend
!ifend
!if (!index(!measure,'FBETA')>0 !and !beta=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Measure FBETA is requested, but BETA is not specified.'.
!ifend
!let !meas= !conc(' ',!measure,' ') !let !macnt= !null !let !mbcnt= !null
!do !w !in (!measure) !let !w_= !conc(' ',!w,' ')
 !if (!index(' ACC REC PRE SPE NPV YOUD MARK F1 FBETA KULCZ2 LNDOR DP CORR BCR GM AGM OPRE JACCARD ',!w_)>0) !then
  !let !macnt= !conc(!macnt,' ')
 !ifend
!doend
!do !w !in (!measure) !let !w_= !conc(' ',!w,' ')
 !if (!index(' OSR KAPPA SPI BPK RKCORR ',!w_)>0) !then
  !let !mbcnt= !conc(!mbcnt,' ')
 !ifend
!doend
!let !macnt= !len(!macnt) !let !mbcnt= !len(!mbcnt)
!let !measa= (!macnt>0) !let !measb= (!mbcnt>0)
!if(!binar='CLASS' !and !measb) !then !let !ok= 0
-echo ''.
-echo '>ERROR. With BINAR=CLASS one cannot request multiclass measures (OSR, KAPPA, SPI, BPK, RKCORR).'.
!ifend
!if (!ok) !then
-echo '**** COMPARISON OF CLASSIFICATIONS (!CLASAGREE) ****'.
-set mxloops 1000000.
-matrix.
-get clas /vari= !clvrs /names= names.
-comp n= nrow(clas).
-comp p= ncol(clas).
-comp misval= -999.999.
 !if (!with) !then !let !rc= 'j-1,col'
- comp s= {t(names(2:ncol(names))),make(p-1,!macnt+!mbcnt,misval)}.
 !else !let !rc= 'i,j'
- comp s= make(p,p,misval).
 !ifend
-comp ncat= 0.
-comp codes= 0.
-comp des= make(n,1,0).
-loop i= 1 to p.
- comp clasi= clas(:,i).
- comp desi= design(clasi).
- comp ncat= {ncat,ncol(desi)}.
- comp des= {des,desi}.
- comp codesi= clasi*make(1,ncol(desi),1)&*desi.
- comp codes= {codes,cmax(codesi)+cmin(codesi)}.
-end loop.
-comp ncat= ncat(2:ncol(ncat)).
-comp codes= codes(2:ncol(codes)).
-comp des= des(:,2:ncol(des)).
-release clas.
-loop i= 1 to !nit.
- comp ncati= ncat(i).
- comp desi= des(:,1:ncati).
- comp des= des(:,(ncati+1):ncol(des)).
- comp codesi= t(codes(1:ncati)).
- comp codes= codes((ncati+1):ncol(codes)).
- comp pilei= t(desi)*des.
- comp shift= 0.
- loop j= i+1 to p.
-  comp end= ncat(j).
-  comp indvec= 1:end+shift.
-  comp m= pilei(:,indvec).
-  comp codesj= codes(indvec).
-  comp match= codesi*make(1,ncol(m),1)=codesj(make(1,nrow(m),1),:).
-  comp shift= indvec(end).
   !if (!print='YES') !then
-   print {i,j} /title 'Variable numbers (i,j)'.
-   print names({i,j}) /title 'Variable names (i,j)' /format=a8 /space= 0.
-   print {-999,codesj;codesi,m} /title 'Frequency crosstabulation (i * j) [codes in 1st column and row]' /space= 0.
-   print {-999,codesj;codesi,match} /title 'Flag of same-coded groups' /space= 0.
   !ifend
-  comp rs= rsum(m).
-  comp cs= csum(m).
-  comp cind= rmax(match&*(1:ncol(m))(make(1,nrow(m),1),:)).
-  comp nm= msum(match).
-  do if nm.
-   comp col= 1.
    !if (!measa) !then
-    comp tp= m&*match.
-    comp fn= (rs*make(1,ncol(m),1)-tp)&*match.
-    comp fp= (cs(make(1,nrow(m),1),:)-tp)&*match.
-    comp tn= (n-tp-fn-fp)&*match.
-    comp a= make(nm,1,0).
-    comp b= make(nm,1,0).
-    comp c= make(nm,1,0).
-    comp d= make(nm,1,0).
-    comp mcodes= make(nm,1,0).
-    comp rw_= make(nm,1,0).
-    comp cnt= 0.
-    loop rn= 1 to nrow(cind).
-     comp cn= cind(rn).
-     do if cn.
-      comp cnt= cnt+1.
-      comp a(cnt)= tp(rn,cn).
-      comp b(cnt)= fn(rn,cn).
-      comp c(cnt)= fp(rn,cn).
-      comp d(cnt)= tn(rn,cn).
-      comp mcodes(cnt)= codesi(rn).
-      comp rw_(cnt)= rs(rn).
-     end if.
-    end loop.
-    release tp,fn,fp,tn.
     !if (!print='YES' !and !measa) !then
-     print /title 'True Positive, False Negative, False Positive, True Negative counts, for each class' /space= 0.
-     print {mcodes,a,b,c,d} /title '[reference classification - i (crosstab rows), and predicted - j (crosstab columns)]'
                             /clab= 'Code' 'TP(a)' 'FN(b)' 'FP(c)' 'TN(d)' /space=0.
     !ifend
     !if (!binar<>'CLASS') !then !let !notclass= 1 !let !bnr= !binar !let !sc= !conc('s(',!rc,')') !let !ast= '*'
      !if (!binar='IWMEAN') !then
-      comp rw= 1/rw_.
      !else !if (!binar='WMEAN') !then
-      comp rw= rw_.
      !else !let !bnr= 'MEAN'
-      comp rw= make(nm,1,1).
      !ifend !ifend
      !let !otnote= !conc('/footnote=',!quote(!conc('NOTE: Averaged binary comparison measures (*) obtained by method ',!bnr)))
-     comp rws= csum(rw).
-    !else !let !notclass= 0 !let !sc= 'sc(:,col)'
      !let !otnote= '/footnote= "NOTE: Binary comparison measures are given for each class (code)"'
     !ifend
-    comp sc= {mcodes,make(nm,!macnt,0)}.
     !if (!index(!meas,' REC ')>0 !or !index(!meas,' PRE ')>0 !or !index(!meas,' SPE ')>0 !or !index(!meas,' NPV ')>0 !or !index(!meas,' MARK ')>0
          !or !index(!meas,' YOUD ')>0 !or !index(!meas,' F1 ')>0 !or !index(!meas,' FBETA ')>0 !or !index(!meas,' KULCZ2 ')>0
          !or !index(!meas,' BCR ')>0 !or !index(!meas,' GM ')>0 !or !index(!meas,' AGM ')>0 !or !index(!meas,' OPRE ')>0) !then
-     comp rec= a/(a+b).
-     comp pre= a/(a+c).
-     comp spe= d/(d+c).
-     comp npv= d/(d+b).
      !if (!notclass) !then
-      comp rec= csum(rw&*rec)/rws.
-      comp pre= csum(rw&*pre)/rws.
-      comp spe= csum(rw&*spe)/rws.
-      comp npv= csum(rw&*npv)/rws.
      !ifend
     !ifend
     !if (!index(!meas,' ACC ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' acc') !let !vlab= !conc(!vlab,' acc ',!quote(!conc('Accuracy',!ast))) !ifend
-     comp col= col+1.
-     comp sc(:,col)= (a+d)/n.
      !if (!notclass) !then
-      comp !sc= csum(rw&*sc(:,col))/rws.
      !ifend
     !ifend
     !if (!index(!meas,' REC ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' rec') !let !vlab= !conc(!vlab,' rec ',!quote(!conc('Recall',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= rec.
     !ifend
     !if (!index(!meas,' SPE ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' spe') !let !vlab= !conc(!vlab,' spe ',!quote(!conc('Specificity',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= spe.
     !ifend
     !if (!index(!meas,' YOUD ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' youd') !let !vlab= !conc(!vlab,' youd ',!quote(!conc('Youden',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= rec+spe-1.
     !ifend
     !if (!index(!meas,' PRE ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' pre') !let !vlab= !conc(!vlab,' pre ',!quote(!conc('Precision',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= pre.
     !ifend
     !if (!index(!meas,' NPV ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' npv') !let !vlab= !conc(!vlab,' npv ',!quote(!conc('Negative Predictive Value',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= npv.
     !ifend
     !if (!index(!meas,' MARK ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' mark') !let !vlab= !conc(!vlab,' mark ',!quote(!conc('Markedness',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= pre+npv-1.
     !ifend
     !if (!index(!meas,' F1 ')>0 !or !index(!meas,' FBETA ')>0) !then
-     comp prerec0= pre+rec=0.
      !if (!index(!meas,' F1 ')>0) !then
       !if (!with) !then !let !vnam= !conc(!vnam,' f1') !let !vlab= !conc(!vlab,' f1 ',!quote(!conc('F1-measure',!ast))) !ifend
-      comp col= col+1.
-      comp !sc= 2*pre&*rec/(pre+rec+prerec0)+misval*prerec0.
      !ifend
      !if (!index(!meas,' FBETA ')>0) !then
       !if (!with) !then !let !vnam= !conc(!vnam,' fbeta') !let !vlab= !conc(!vlab,' fbeta ',!quote(!conc('Fbeta-measure [',!beta,']',!ast))) !ifend
-      comp col= col+1.
-      comp beta2= !beta**2.
-      comp !sc= (1+beta2)*pre&*rec/(beta2*pre+rec+prerec0)+misval*prerec0.
      !ifend
-     release prerec0.
     !ifend
     !if (!index(!meas,' KULCZ2 ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' kulcz2') !let !vlab= !conc(!vlab,' kulcz2 ',!quote(!conc('Kulczynski 2',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= (rec+pre)/2.
     !ifend
     !if (!index(!meas,' LNDOR ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' lndor') !let !vlab= !conc(!vlab,' lndor ',!quote(!conc('Log Diagnostic Odds Ratio',!ast))) !ifend
-     comp col= col+1.
-     comp adbcn0= a&*d&*b&*c>0.
-     do if all(adbcn0).
-      comp sc(:,col)= ln(a&*d/(b&*c)).
       !if (!notclass) !then
-       comp !sc= csum(rw&*sc(:,col))/rws.
       !ifend
-     else.
       !if (!not !notclass) !then
-       comp sc(:,col)= make(nm,1,misval).
-       loop r= 1 to nm.
-        do if adbcn0(r).
-         comp sc(r,col)= ln(a(r)*d(r)/(b(r)*c(r))).
-        end if.
-       end loop.
       !ifend
-     end if.
-     release adbcn0.
     !ifend
     !if (!index(!meas,' DP ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' dp') !let !vlab= !conc(!vlab,' dp ',!quote(!conc('Discriminant Power',!ast))) !ifend
-     comp col= col+1.
-     comp rec_= a/(a+b).
-     comp spe_= d/(d+c).
-     comp r01s01= not(rec_=1 or rec_=0 or spe_=1 or spe_=0).
-     do if all(r01s01).
-      comp sc(:,col)= .5513289*(ln(rec_/(1-spe_))+ln(spe_/(1-rec_))).
       !if (!notclass) !then
-       comp !sc= csum(rw&*sc(:,col))/rws.
       !ifend
-     else.
       !if (!not !notclass) !then
-       comp sc(:,col)= make(nm,1,misval).
-       loop r= 1 to nm.
-        do if r01s01(r).
-         comp sc(r,col)= .5513289*(ln(rec_(r)/(1-spe_(r)))+ln(spe_(r)/(1-rec_(r)))).
-        end if.
-       end loop.
       !ifend
-     end if.
-     release r01s01,rec_,spe_.
     !ifend
     !if (!index(!meas,' CORR ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' corr') !let !vlab= !conc(!vlab,' corr ',!quote(!conc('Matthews corr',!ast))) !ifend
-     comp col= col+1.
-     comp paij= a/n.
-     comp pi_=(a+b)/n.
-     comp p_j=(a+c)/n.
      !if (!notclass) !then
-      comp paij= csum(rw&*paij)/rws.
-      comp pi_= csum(rw&*pi_)/rws.
-      comp p_j= csum(rw&*p_j)/rws.
      !ifend
-     comp !sc= (paij-pi_&*p_j)/sqrt(pi_&*p_j&*(1-pi_)&*(1-p_j)).
-     release paij,pi_,p_j.
     !ifend
     !if (!index(!meas,' BCR ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' bcr') !let !vlab= !conc(!vlab,' bcr ',!quote(!conc('Balanced Classification Rate',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= (rec+spe)/2.
     !ifend
     !if (!index(!meas,' GM ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' gm') !let !vlab= !conc(!vlab,' gm ',!quote(!conc('GM measure',!ast))) !ifend
-     comp col= col+1.
-     comp !sc= sqrt(rec&*spe).
     !ifend
     !if (!index(!meas,' AGM ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' agm') !let !vlab= !conc(!vlab,' agm ',!quote(!conc('Adjusted GM measure',!ast))) !ifend
-     comp col= col+1.
-     comp dcn= (d+c)/n.
      !if (!notclass) !then
-      comp dcn= csum(rw&*dcn)/rws.
      !ifend
-     comp !sc= (sqrt(rec&*spe)+spe&*dcn)/(1+dcn)&*(rec>0).
-     release dcn.
     !ifend
     !if (!index(!meas,' OPRE ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' opre') !let !vlab= !conc(!vlab,' opre ',!quote(!conc('Optimized Precision',!ast))) !ifend
-     comp col= col+1.
-     comp recspe0= rec+spe=0.
-     comp acc= (a+d)/n.
      !if (!notclass) !then
-      comp acc= csum(rw&*acc)/rws.
      !ifend
-     comp !sc= acc-abs(rec-spe)/(rec+spe+recspe0)+misval*recspe0.
-     release recspe0,acc.
     !ifend
     !if (!index(!meas,' JACCARD ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' jaccard') !let !vlab= !conc(!vlab,' jaccard ',!quote(!conc('Jaccard',!ast))) !ifend
-     comp col= col+1.
-     comp sc(:,col)= a/(a+b+c).
      !if (!notclass) !then
       comp !sc= csum(rw&*sc(:,col))/rws.
      !ifend
     !ifend
-    release a,b,c,d.
     !if (!not !notclass) !then
      !let !cod= 'code_ n_' !let !codlbl= !conc('code_ "Class code" n_ ',!quote(!conc('N in class (',!head(!vars),')')))
-     save {make(nm,1,s(j-1,1)),sc(:,1),rw_,sc(:,2:ncol(sc))} /out= * /vari= varname_ code_ n_ !vnam /string= varname_.
     !ifend
-    release sc.
    !ifend
    !if (!measb) !then !let !notclass= 1
     !if (!with) !then
-     comp col= !macnt+1.
     !ifend
     !if (!index(!meas,' OSR ')>0 !or !index(!meas,' KAPPA ')>0 !or !index(!meas,' SPI ')>0 !or !index(!meas,' BPK ')>0) !then
-     comp osr= msum(m&*match)/n.
      !if (!index(!meas,' OSR ')>0) !then
       !if (!with) !then !let !vnam= !conc(!vnam,' osr') !let !vlab= !conc(!vlab,' osr "Overall Success (Agreement) Rate"')
-       comp col= col+1.
       !ifend
-      comp s(!rc)= osr.
      !ifend
      !if (!index(!meas,' KAPPA ')>0) !then
       !if (!with) !then !let !vnam= !conc(!vnam,' kappa') !let !vlab= !conc(!vlab,' kappa "Cohen Kappa"')
-       comp col= col+1.
       !ifend
-      comp pexp= 0.
-      loop r= 1 to nrow(cind).
-       do if cind(r).
-        comp pexp= pexp+rs(r)*cs(cind(r)).
-       end if.
-      end loop.
-      comp pexp= pexp/n**2.
-      comp s(!rc)= (osr-pexp)/(1-pexp).
      !ifend
      !if (!index(!meas,' SPI ')>0) !then
       !if (!with) !then !let !vnam= !conc(!vnam,' spi') !let !vlab= !conc(!vlab,' spi "Scott Pi"')
-       comp col= col+1.
       !ifend
-      comp pexp= 0.
-      loop r= 1 to nrow(cind).
-       do if cind(r).
-        comp pexp= pexp+(rs(r)+cs(cind(r)))**2.
-       end if.
-      end loop.
-      comp pexp= pexp/(4*n**2).
-      comp s(!rc)= (osr-pexp)/(1-pexp).
      !ifend
      !if (!index(!meas,' BPK ')>0) !then
       !if (!with) !then !let !vnam= !conc(!vnam,' bpk') !let !vlab= !conc(!vlab,' bpk "Brennan-Prediger Kappa"')
-       comp col= col+1.
       !ifend
-      comp pexp= nm/(nrow(m)*ncol(m)).
-      comp s(!rc)= (osr-pexp)/(1-pexp).
      !ifend
     !ifend
     !if (!index(!meas,' RKCORR ')>0) !then
      !if (!with) !then !let !vnam= !conc(!vnam,' rkcorr') !let !vlab= !conc(!vlab,' rkcorr "Multiclass Rk corr"')
-      comp col= col+1.
      !ifend
-     do if nm=nrow(m) and nm=ncol(m).
-      comp rgrd= grade(codesi).
-      comp cgrd= grade(codesj).
-      comp m(rgrd,cgrd)= m.
-      comp rs(rgrd)= rs.
-      comp cs(cgrd)= cs.
-      comp numer= 0.
-      comp denomi= 0.
-      comp denomj= 0.
-      loop x= 1 to nm.
-       loop y= 1 to nm.
-        loop z= 1 to nm.
-         comp numer= numer+m(x,x)*m(y,z)-m(x,y)*m(z,x).
-        end loop.
-       end loop.
-       comp denomi= denomi+rs(x)*(n-rs(x)).
-       comp denomj= denomj+cs(x)*(n-cs(x)).
-      end loop.
-      comp s(!rc)= numer/sqrt(denomi*denomj).
-     else.
-      print /title '>WARNING. Measure RKCORR will not be computed for this pair of variables:'.
-      print {i,j} /title 'variable numbers (i,j)' /space= 0.
-      print names({i,j}) /title 'variable names (i,j)' /format=a8 /space= 0.
-      print /title '>because they contain not fully identical group codes.' /space= 0.
-      print /title '--------' /space= 0.
-     end if.
     !ifend
    !ifend
-  else.
-   print /title '>WARNING. The following two variables do not have common codes:'.
-   print {i,j} /title 'variable numbers (i,j)' /space= 0.
-   print names({i,j}) /title 'variable names (i,j)' /format=a8 /space= 0.
-   print /title '>Measures of agreement will not be computed for this pair.' /space= 0.
-   print /title '--------' /space= 0.
    !if (!not !notclass) !then
-    save {s(j-1,1),make(1,!macnt+2,misval)} /out= * /vari= varname_ code_ n_ !vnam /string= varname_.
    !ifend
-  end if.
- end loop.
-end loop.
-release des.
 !if (!not !with) !then !let !w_= !conc(' ',!measure,' ')
  !if (!index(' OSR KAPPA SPI BPK RKCORR ',!w_)>0 !or
      ((!binar='MEAN' !or !binar=!null) !and !index(' ACC F1 KULCZ2 LNDOR DP CORR JACCARD ',!w_)>0)) !then
-  comp snemis= s<>misval.
-  comp s= s-misval*t(snemis)+t(s&*snemis).
  !else
-  print /title '>REMINDER. The computed measure is asymmetric, so only upper triangle'.
-  print /title ' of the matrix will be output.' /space= 0.
  !ifend
  !if (!measure='LNDOR' !or !measure='DP') !then
-  call setdiag(s,999).
  !else
-  call setdiag(s,1).
  !ifend
 !ifend
 !if (!notclass) !then
  !if (!with) !then
-  save s /out= * /vari= varname_ /string= varname_.
  !else
-  comp vnam= {'rowtype_','varname_',names}.
-  save {make(p,1,'PROX'),t(names),s} /out= * /names= vnam /string= rowtype_ varname_.
  !ifend
 !ifend
-end matrix.
 !if (!with) !then
- rename vari (all=varname_ !cod !vnam).
- var lab  varname_ !quote(!conc('Classifications compared with classification ',!head(!vars))) !codlbl !vlab.
- format !vnam (f8.3).
- recode !cod !vnam (-999.999=sysmis).
- echo '** COMPARISON OF CLASSIFICATIONS - Results **'.
- summarize /tables= all /format= list nocasenum nototal /cells= none /title= 'Classifications comparison' !otnote.
 !else
- echo 'Square matrix of the requested measure was output in the new working dataset'.
  !do !w !in (!vars) !let !lstvar= !w !doend
- recode !head(!vars) to !lstvar (-999.999=sysmis).
- exec.
- var lev all (sca) rowtype_ to varname_ (nom).
- val lab rowtype_ 'PROX' !quote(!conc('SIMILARITY ',!measure)).
 !ifend
!else
-echo '>!KO_CLASAGREE is not executed.'.
-exec.
!ifend
!enddefine.

*/*!KO_GRMATCH*/vers1*************************************************************************.
define !KO_grmatch(vars= !charend('/') /matchon= !charend('/') /method= !charend('/') /recode= !charend('/') /other= !charend('/')
                /simmx= !charend('/') /print= !charend('/'))
!let !ok= 1
!if (!method=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. METHOD is not specified.'.
!ifend
!if (!print='NO' !and (!recode='NO' !or !recode=!null) !and !simmx<>'YES') !then !let !ok= 0
- echo ''.
- echo '>ERROR. PRINT=NO and neither RECODE nor SIMMX is specified, i.e. results not requested.'.
- echo '>There is no job for the macro.'.
!ifend
!if (!head(!tail(!vars))='WITH') !then
 !let !clvrs= !conc(!head(!vars),!tail(!tail(!vars))) !let !nit= 1
 !if (!simmx='YES') !then !let !ok= 0
- echo ''.
- echo '>ERROR. SIMMX=YES requires keyword WITH be absent in VARS.'.
 !ifend
!else !let !clvrs= !vars !let !nit= 'p-1'
 !if (!recode<>'NO' !and !recode<>!null) !then !let !ok= 0
- echo ''.
- echo ">ERROR. RECODE= YES or 'file' requires keyword WITH in VARS.".
 !ifend
!ifend
!if (!ok) !then !let !msav= 0
-set mxloops 1000000.
-matrix.
-get clas /vari= !clvrs /names= names.
-comp p= ncol(clas).
-comp ncat= 0.
-comp codes= 0.
-comp vnam= 0.
-comp des= make(nrow(clas),1,0).
-loop i= 1 to p.
- comp clasi= clas(:,i).
- comp desi= design(clasi).
- comp ncat= {ncat,ncol(desi)}.
- comp des= {des,desi}.
- comp codesi= clasi*make(1,ncol(desi),1)&*desi.
- comp codes= {codes,cmax(codesi)+cmin(codesi)}.
 !if (!simmx='YES') !then !let !msav= 1
- comp vnam= {vnam,make(1,ncol(desi),names(i))}.
 !ifend
-end loop.
-comp ncat= ncat(2:ncol(ncat)).
-comp codes= codes(2:ncol(codes)).
-comp des= des(:,2:ncol(des)).
 !if (!msav) !then
- comp vnam= vnam(2:ncol(vnam)).
- comp cds= codes.
 !ifend
-release clas.
 !if (!print<>'NO') !then
- print /title '**** PAIRWISE CROSSTABULATIONS OF PARTITIONS WITH INDICATION OF MUTUALLY CORRESPONDENT GROUPS ****'.
 !ifend
-loop i= 1 to !nit.
- comp ncati= ncat(i).
- comp namei= names(i).
- comp desi= des(:,1:ncati).
- comp des= des(:,(ncati+1):ncol(des)).
- comp codesi= t(codes(1:ncati)).
- comp codes= codes((ncati+1):ncol(codes)).
- comp pilei= t(desi)*des.
  !if (!msav) !then
-  comp mxi= make(ncati,ncati,-.5).
  !ifend
- comp shift= 0.
- loop j= i+1 to p.
-  comp namej= names(j).
-  comp end= ncat(j).
-  comp indvec= 1:end+shift.
-  comp m= pilei(:,indvec).
-  comp codesj= codes(indvec).
-  comp shift= indvec(end).
   !if (!matchon='RESID') !then !let !tabt= 'Residuals:'
-   comp m= m-rsum(m)*csum(m)/msum(m).
   !else !if (!matchon='FCELL') !then !let !tabt= 'F-measures:'
-   comp m= 2*m/(rsum(m)*make(1,ncol(m),1)+csum(m)(make(1,nrow(m),1),:)).
   !else !let !tabt= 'Counts:'
   !ifend !ifend
   !if (!method='GREEDY' !or !method='PGREEDY') !then
-   comp match= make(nrow(m),ncol(m),0).
-   comp m_= m.
-   comp @rns= 1:nrow(m_).
-   comp @cns= 1:ncol(m_).
-   comp @nst= rmin({nrow(m_),ncol(m_)}).
    !if (!method='PGREEDY') !then !let !ifmax= 'do if @val=@rmax(@rns(@ri)) and @val=@cmax(@cns(@ci))' !let !endif= 'end if'
-    comp @rmax= rmax(m_).
-    comp @cmax= cmax(m_).
    !ifend
-   loop @i= 1 to @nst.
-    comp @val= mmax(m_).
-    comp @flag= m_=@val.
-    comp @ri= mmax(@flag&*(t((1:nrow(m_)))*make(1,ncol(m_),1))).
-    comp @ci= mmax(@flag(@ri,:)&*(1:ncol(m_))).
-    !ifmax.
-     comp match(@rns(@ri),@cns(@ci))= 1.
-    !endif.
-    do if @i<@nst.
-     do if @ri=1.
-      comp @rind= 2:nrow(m_).
-     else if @ri=nrow(m_).
-      comp @rind= 1:(@ri-1).
-     else.
-      comp @rind= {1:(@ri-1),(@ri+1):nrow(m_)}.
-     end if.
-     do if @ci=1.
-      comp @cind= 2:ncol(m_).
-     else if @ci=ncol(m_).
-      comp @cind= 1:(@ci-1).
-     else.
-      comp @cind= {1:(@ci-1),(@ci+1):ncol(m_)}.
-     end if.
-     comp m_= m_(@rind,@cind).
-     comp @rns= @rns(@rind).
-     comp @cns= @cns(@cind).
-    end if.
-   end loop.
-   release m_,@rns,@cns,@nst,@i,@val,@flag,@ri,@ci,@rind,@cind.
   !else
-   comp m_= m.
-   do if nrow(m)<ncol(m).
-    comp m_= t(m_).
-   end if.
-   comp m#= mmax(m_)-m_.
-   do if nrow(m#)>ncol(m#).
-    comp m#= {m#,make(nrow(m#),nrow(m#)-ncol(m#),0)}.
-   end if.
-   comp @n= nrow(m#).
-   comp @rzero= make(1,@n,0).
-   comp @czero= make(@n,1,0).
-   comp @rnums= t(1:@n).
-   comp @cnums= 1:@n.
-   comp m#= m#-rmin(m#)*make(1,@n,1).
-   comp @m= (not m#)&*@cnums(make(1,@n,1),:).
-   loop @i= 1 to @n.
-    comp @j= rmax(@m(@i,:)).
-    do if @j.
-     comp @m(@i,:)= @rzero.
-     comp @m(:,@j)= @czero.
-     comp @m(@i,@j)= 1.
-    end if.
-   end loop.
-   loop.
-    comp @ucr= make(@n,1,1).
-    comp @ucc= not csum(@m).
-    do if not any(@ucc).
-     break.
-    else.
-     loop.
-      comp @i= 0.
-      loop @j= 1 to @n.
-       do if @ucc(@j).
-        comp @i= cmax((not m#(:,@j))&*@ucr&*@rnums).
-        do if @i.
-         break.
-        end if.
-       end if.
-      end loop.
-      do if @i.
-       comp @m(@i,@j)= -2.
-       do if any(@m(@i,:)=1).
-        comp @ucr(@i)= 0.
-        comp @ucc(rmax(@m(@i,:)&*@cnums))= 1.
-       else.
-        comp @m(@i,@j)= -3.
-        loop if any(@m(:,@j)=1).
-         comp @i2= cmax(@m(:,@j)&*@rnums).
-         comp @m(@i2,@j)= 0.
-         comp @j2= rmax((@m(@i2,:)=-2)&*@cnums).
-         comp @m(@i2,@j2)= -3.
-         comp @j= @j2.
-        end loop.
-        comp @m= @m&*(@m<>-3)+(@m=-3).
-        comp @m= @m&*(@m<>-2).
-        break.
-       end if.
-      else.
        !do !w !in ("'@ucr @rind' '@ucc @cind'")
         !let !w0= !unquote(!w) !let !w1= !head(!w0) !let !w2= !tail(!w0)
-        comp @nnz= msum(!w1).
-        do if @nnz=@n.
-         comp !w2= @cnums.
-        else if @nnz/@n>.8.
-         comp !w2= make(1,@nnz+1,0).
-         comp @cnt= 1.
-         loop @#= 1 to @n.
-          comp !w2(@cnt)= @#.
-          comp @cnt= @cnt+!w1(@#).
-         end loop.
-         comp !w2= !w2(1:@nnz).
-        else.
-         comp !w2= make(1,@nnz,0).
-         comp @cnt= 0.
-         loop @#= 1 to @n.
-          do if !w1(@#).
-           comp @cnt= @cnt+1.
-           comp !w2(@cnt)= @#.
-          end if.
-         end loop.
-        end if.
        !doend
-       comp @min= mmin(m#(@rind,@cind)).
-       comp m#= m#+(not @ucr)*make(1,@n,@min)-make(@n,1,@min)*@ucc.
-       release @nnz,@rind,@cind,@cnt,@#.
-      end if.
-     end loop.
-    end if.
-   end loop.
-   comp match= make(nrow(m_),ncol(m_),0).
-   loop @j= 1 to ncol(m_).
-    comp match(cmax(@m(:,@j)&*@rnums),@j)= 1.
-   end loop.
-   do if nrow(m)<ncol(m).
-    comp match= t(match).
-   end if.
-   release m_,m#,@m,@n,@rzero,@czero,@rnums,@cnums,@ucr,@ucc,@i,@j.
   !ifend
   !if (!print<>'NO') !then
-   print /title '---------------------------'.
-   print {namei,' * ',namej} /title 'Crosstabulation' /format= a8 /space= 0.
-   print {-999,codesj;codesi,m} /title !quote(!tabt).
-   print {-999,codesj;codesi,match} /title 'Matchings:'.
-   print msum(m&*match) /title 'Sum in matchings:'.
-   print /space= 1.
   !ifend
   !if (!recode<>'NO' !and !recode<>!null) !then !let !wexec= "write 'exec.' /field= 1 to 5 /format= a5"
    !if (!recode='YES') !then !let !file= !quote('temp_KO_grmatch.sps') !else !let !file= !recode !ifend
-   comp matchv= reshape(match,nrow(m)*ncol(m),1).
-   comp recci= kroneker(codesi,make(ncol(m),1,1)).
-   comp reccj= kroneker(make(nrow(m),1,1),t(codesj)).
-   write {'recode',namej} /out= !file /field= 1 to 17 /format= a8.
-   loop indx= 1 to nrow(matchv).
-    do if matchv(indx).
-     write '(' /field= 3 to 28 /format= a1 /hold.
-     write reccj(indx) /field= 3 to 28 /format= f8.2 /hold.
-     write ' =' /field= 3 to 28 /format= a2 /hold.
-     write recci(indx) /field= 3 to 28 /format= f8.2 /hold.
-     write ' )' /field= 3 to 28 /format= a2.
-    end if.
-   end loop.
-   comp otr= not csum(match).
-   do if any(otr).
     !if (!other='INDIVID' !or !other=!null) !then
-     comp codesi_= codesi.
-     loop indx= 1 to ncol(m).
-      do if otr(indx).
-       comp otrcode= codesj(indx). /*(Вот он)
-       loop frac= 1 to 99 if any(codesi_=otrcode).
-        comp otrcode= otrcode+frac/100.
-       end loop.
-       comp codesi_= {codesi_;otrcode}.
-       write '(' /field= 3 to 28 /format= a1 /hold.
-       write codesj(indx) /field= 3 to 28 /format= f8.2 /hold.
-       write ' =' /field= 3 to 28 /format= a2 /hold.
-       write otrcode /field= 3 to 28 /format= f8.2 /hold.
-       write ' )' /field= 3 to 28 /format= a2.
-      end if.
-     end loop.
     !else
-     write '( else =' /field= 3 to 28 /format= a8 /hold.
-     write !other /field= 3 to 28 /format= f8.2 /hold.
-     write ' )' /field= 3 to 28 /format= a2.
     !ifend
-   end if.
-   write '.' /field= 1 to 1 /format= a1.
   !ifend
   !if (!msav) !then
-   comp mxi= {mxi,match}.
   !ifend
- end loop.
  !if (!msav) !then
-  do if i=1.
-   comp mx= mxi.
-  else.
-   comp mx= {mx;{make(ncati,ncol(mx)-ncol(mxi),0),mxi}}.
-  end if.
  !ifend
-end loop.
-!wexec.
 !if (!msav) !then
- comp mx= {mx;{make(ncol(match),nrow(mx),0),make(ncol(match),ncol(match),-.5)}}.
- comp mx= mx+t(mx).
- call setdiag(mx,1).
- save {t(vnam),t(cds),mx} /out= * /vari= id codes var1 to var10000 /string= id.
 !ifend
-end matrix.
 !if (!recode='YES') !then
- insert file= !file.
- echo 'Input variables VARS following after WITH were recoded by the macro.'.
- echo 'If these variables had value labels these former labels may not be valid now.'.
- erase file !file.
 !else !if (!recode<>'NO' !and !recode<>!null) !then
- echo 'Syntax to recode input variables VARS following after WITH'.
- echo 'was saved as file'.
- echo !file.
 !ifend !ifend
 !if (!msav) !then
- set results none errors none.
- matrix.
- get mx /names= vnam.
- comp vnam= vnam(3:ncol(vnam)).
- comp names= {'rowtype_','id','codes','varname_',vnam}.
- save {make(nrow(mx),1,'PROX'),mx(:,1:2),t(vnam),mx(:,3:ncol(mx))} /out= * /names= names /string= rowtype_ id varname_.
- end matrix.
- format codes (f8.2).
- alter type id (a16) codes (amin) /print none.
- comp codes= rtrim(rtrim(codes,'0'),'.').
- if codes='' codes= '0'.
- comp id= conc(rtrim(id),',',rtrim(codes)).
- exec.
- del var codes.
- val lab rowtype_ 'PROX' 'SIMILARITY (1= MATCHED CATEGORIES)'.
- var lev all (sca) rowtype_ varname_ id (nom).
- set results list errors list.
- echo '**** CATEGORIES CLUSTERIZATION ****'.
- echo 'Mutually correspondent groups (categories) of different partitions'.
- echo 'are merged in the left part of the dendrogram.'.
- cluster  /matrix= in(*) /id= id /method= complete /print= none /plot= dendro.
 !ifend
!else
-echo '>!KO_GRMATCH is not executed.'.
-exec.
!ifend
!enddefine.
